define(
    [
        'jquery',
        'uiComponent',
        'ko',
        'Magento_Checkout/js/model/quote',
        'Magento_Customer/js/model/customer',
        'Magento_Checkout/js/model/url-builder',
        'mage/storage',
        "Magento_Checkout/js/model/error-processor",
        "Magento_Ui/js/model/messages",
        "Magento_Checkout/js/action/get-totals"
    ], function ($, uiComponent, ko, quote, customer, urlBuilder, storage, errorProcessor, Messages, getTotalsAction) {
        'use strict';

        return function (paymentMethod) {
            quote.paymentMethod(paymentMethod);

            var paymentData = paymentMethod;

            // We have to make sure we don't send title to the backend,
            // otherwise it will fail. Perhaps there is better way to do this.
            paymentData = JSON.parse(JSON.stringify(paymentData));
            if (paymentData) {

                if (paymentData['title']) delete paymentData['title'];
                if (paymentData["__disableTmpl"]) delete paymentData["__disableTmpl"]; //Fix for Magento 2.3+

                var serviceUrl;
                if (customer.isLoggedIn()) {
                    serviceUrl = urlBuilder.createUrl('/carts/mine/selected-payment-method', {});
                } else {
                    serviceUrl = urlBuilder.createUrl('/guest-carts/:cartId/selected-payment-method', {
                        cartId: quote.getQuoteId()
                    });
                }

                var payload = {
                    cartId: quote.getQuoteId(),
                    method: paymentData
                };

                storage.put(
                    serviceUrl,
                    JSON.stringify(payload),
                    false
                ).fail(function (response) {
                    var messageContainer = new Messages();
                    errorProcessor.process(response, messageContainer);
                }).done(function () {
                    getTotalsAction([]);
                });
            }

        }
    });
